//
//  AppController.m
//  UpTime
//
//  Created by Milo on 20/06/2007.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import "AppController.h"

NSString *MBCurrentUpTime = @"MBCurrentUpTime";
NSString *MBDateOfCurrentUpTime = @"MBDateOfCurrentUpTime";
NSString *MBLongestRecordedUpTime = @"MBLongestRecordedUpTime";
NSString *MBLastTenRecordedUpTimes = @"MBLastTenRecordedUpTimes";


@implementation AppController

//  NSObject
- (id)init;
{
	if ([super init] == nil)
		return nil;
	
	//  If the time elapsed since the current uptime was last recorded is greater than the increase in the uptime, then the computer must have been restarted in the meantime. We will allow for an innacuracy in the calculation of up to 10 seconds.
	if ([self currentUpTime] != nil && [[NSDate date] timeIntervalSinceDate:[[NSUserDefaults standardUserDefaults] objectForKey:MBDateOfCurrentUpTime]] - ([[NSNumber numberWithCurrentUpTime] doubleValue] - [[self currentUpTime] doubleValue]) > 10)
	{
		NSMutableArray *lastTenUpTimes = [[self lastTenRecordedUpTimes] mutableCopy];
		if (lastTenUpTimes == nil)
			lastTenUpTimes = [[NSMutableArray alloc] initWithCapacity:10];
		[lastTenUpTimes insertObject:[self currentUpTime] atIndex:0];
		if ([lastTenUpTimes count] > 10)
			[lastTenUpTimes removeLastObject];
		[self setLastTenRecordedUpTimes:lastTenUpTimes];
		[lastTenUpTimes release];
	}
	
	[self updateCurrentUpTime];
	[NSTimer scheduledTimerWithTimeInterval:60.0 target:self selector:@selector(updateCurrentUpTime) userInfo:nil repeats:YES];
		
	return self;
}

#pragma mark -

- (void)updateCurrentUpTime;
{
	[self setCurrentUpTime:[NSNumber numberWithCurrentUpTime]];
}

- (NSNumber *)currentUpTime;
{
	return [[NSUserDefaults standardUserDefaults] objectForKey:MBCurrentUpTime];
}

- (void)setCurrentUpTime:(NSNumber *)newUpTime;
{
	[[NSUserDefaults standardUserDefaults] setObject:newUpTime forKey:MBCurrentUpTime];
	[[NSUserDefaults standardUserDefaults] setObject:[NSDate date] forKey:MBDateOfCurrentUpTime];
	
	if ([self longestRecordedUpTime] == nil || [newUpTime compare:[self longestRecordedUpTime]] == NSOrderedDescending)
		[self setLongestRecordedUpTime:newUpTime];
}

- (NSNumber *)longestRecordedUpTime;
{
	return [[NSUserDefaults standardUserDefaults] objectForKey:MBLongestRecordedUpTime];
}

- (void)setLongestRecordedUpTime:(NSNumber *)newUpTime;
{
	[[NSUserDefaults standardUserDefaults] setObject:newUpTime forKey:MBLongestRecordedUpTime];
}

- (NSArray *)lastTenRecordedUpTimes;
{
	return [[NSUserDefaults standardUserDefaults] objectForKey:MBLastTenRecordedUpTimes];
}

- (void)setLastTenRecordedUpTimes:(NSArray *)newUpTimes;
{
	[[NSUserDefaults standardUserDefaults] setObject:newUpTimes forKey:MBLastTenRecordedUpTimes];
}

@end


#pragma mark -
@implementation NSNumber (MBUpTimeAdditions)

+ (id)numberWithCurrentUpTime;
{
	return [self numberWithDouble:(double)UnsignedWideToUInt64(AbsoluteToNanoseconds(UpTime())) / 1000000000];	// UpTime in seconds
}

@end